; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    repargof MACRO arg
      LOCAL nustr
        quot SUBSTR <arg>,1,1
      IFIDN quot,<">            ;; if 1st char = "
        .data
          nustr db arg,0        ;; write arg to .DATA section
        .code
        EXITM <OFFSET nustr>    ;; append name to OFFSET operator
      ELSE
        EXITM <arg>             ;; else return arg
      ENDIF
    ENDM

    op_type MACRO var
      IF (OPATTR (var)) and 00000001y       ;; 0 label
        EXITM %0
      ELSEIF (OPATTR (var)) and 00000010y   ;; 1 memory operand
        EXITM %1
      ELSEIF (OPATTR (var)) and 00000100y   ;; 2 immediate
        EXITM %2
      ELSEIF (OPATTR (var)) and 00010000y   ;; 4 register
        EXITM %4
      ELSE
        EXITM %64
      ENDIF
    ENDM

    argcount MACRO args:VARARG
      LOCAL cnt
      cnt = 0
      FOR item, <args>
        cnt = cnt + 1
      ENDM
      EXITM %cnt                ;; return as a number
    ENDM

    getarg MACRO num:REQ,args:VARARG
      LOCAL cnt, txt
      cnt = 0
      FOR arg, <args>
        cnt = cnt + 1
        IF cnt EQ num
          txt TEXTEQU <arg>     ;; set "txt" to content of arg num
          EXITM
        ENDIF
      ENDM
      IFNDEF txt
        txt TEXTEQU <-1>        ;; return -1 if num out of range
      ENDIF
      EXITM txt
    ENDM

  ; *******************************

    cprint MACRO args:VARARG
      LOCAL var,acnt,item,indi
   ;; ----------
      IFNDEF @@n
      .data
        @@n db 13,10,0                          ;; allocate line feed if not defined
      .code
      ENDIF
   ;; ----------
      IFNDEF @@t
      .data
        @@t db 9,0                              ;; allocate tab if not defined
      .code
      ENDIF
   ;; ----------
      push esi
      mov esi, alloc(32768)
      var equ <>
      acnt = argcount(args)
      WHILE acnt NE 0
        var equ <getarg(acnt,args)>
        IFIDN <n>, var
          push OFFSET @@n
          goto bypass
        ENDIF
        IFIDN <t>, var
          push OFFSET @@t
          goto bypass
        ENDIF
        IF op_type(repargof(%var)) EQ 4
          echo --------------------------------------
          echo ERROR Invalid argument in cprint macro
            IF acnt EQ 15
              echo argument 15
            ELSEIF acnt EQ 14
              echo argument 14
            ELSEIF acnt EQ 13
              echo argument 13
            ELSEIF acnt EQ 12
              echo argument 12
            ELSEIF acnt EQ 11
              echo argument 11
            ELSEIF acnt EQ 10
              echo argument 10
            ELSEIF acnt EQ 9
              echo argument 9
            ELSEIF acnt EQ 8
              echo argument 8
            ELSEIF acnt EQ 7
              echo argument 7
            ELSEIF acnt EQ 6
              echo argument 6
            ELSEIF acnt EQ 5
              echo argument 5
            ELSEIF acnt EQ 4
              echo argument 4
            ELSEIF acnt EQ 3
              echo argument 3
            ELSEIF acnt EQ 2
              echo argument 2
            ELSEIF acnt EQ 1
              echo argument 1
            ENDIF
          echo A register or a register return value
          echo from another macro is not allowed as
          echo a macro argument in the cprint macro.
          echo --------------------------------------
          .err
        ELSE
          % push repargof(%var)
        ENDIF
      :bypass
        acnt = acnt - 1
      ENDM
      push esi
      push argcount(args)
      call szMultiCat
      add esp, argcount(args) * 4 + 8           ;; C call stack correction
      print esi
      free esi
      pop esi
    ENDM

  ; *******************************
    .code

start:
   
; 

    call main

    mov eax, input("Press enter to exit")

    exit

; 

main proc

    cls

    cprint n,n,t,"Hello World",n,n

    cprint t,"This is a version number ",ustr$(2),n, \
           t,"of the multiline 'cprint' macro",n, \
           t,"using abbreviated notation for",n,\
           t,"both 'tab' and 'newline' insertion",n,n

  ; --------------------------------------------
  ; uncomment the following to see error display
  ; --------------------------------------------

 ;     cprint t,n,"The result is ",left$("test",3),t,n

    ret

main endp

; 

end start
